if ~defined WSOCK32_INC
define WSOCK32_INC 1

IOCPARM_MASK                                        equ     07FH
IOC_VOID                                            equ     020000000H
IOC_OUT                                             equ     040000000H
IOC_IN                                              equ     080000000H
IOC_INOUT                                           equ     (IOC_IN or IOC_OUT)

FIONREAD                                            equ     (IOC_OUT or (4 and IOCPARM_MASK) shl 16 or 66H shl 8 or 127)
FIONBIO                                             equ     (IOC_IN or (4 and IOCPARM_MASK) shl 16 or 66H shl 8 or 126)
FIOASYNC                                            equ     (IOC_IN or (4 and IOCPARM_MASK) shl 16 or 66H shl 8 or 125)

if ~defined SOCKET_ERROR
    SOCKET_ERROR                                    equ     (-1)
end if

if ~defined FD_READ_BIT
    FD_READ_BIT                                     equ     0
    FD_READ                                         equ     (1 shl FD_READ_BIT)
    FD_WRITE_BIT                                    equ     1
    FD_WRITE                                        equ     (1 shl FD_WRITE_BIT)
    FD_OOB_BIT                                      equ     2
    FD_OOB                                          equ     (1 shl FD_OOB_BIT)
    FD_ACCEPT_BIT                                   equ     3
    FD_ACCEPT                                       equ     (1 shl FD_ACCEPT_BIT)
    FD_CONNECT_BIT                                  equ     4
    FD_CONNECT                                      equ     (1 shl FD_CONNECT_BIT)
    FD_CLOSE_BIT                                    equ     5
    FD_CLOSE                                        equ     (1 shl FD_CLOSE_BIT)
    FD_QOS_BIT                                      equ     6
    FD_QOS                                          equ     (1 shl FD_QOS_BIT)
    FD_GROUP_QOS_BIT                                equ     7
    FD_GROUP_QOS                                    equ     (1 shl FD_GROUP_QOS_BIT)
    FD_ROUTING_INTERFACE_CHANGE_BIT                 equ     8
    FD_ROUTING_INTERFACE_CHANGE                     equ     (1 shl FD_ROUTING_INTERFACE_CHANGE_BIT)
    FD_ADDRESS_LIST_CHANGE_BIT                      equ     9
    FD_ADDRESS_LIST_CHANGE                          equ     (1 shl FD_ADDRESS_LIST_CHANGE_BIT)
    FD_MAX_EVENTS                                   equ     10
    FD_ALL_EVENTS                                   equ     ((1 shl FD_MAX_EVENTS) - 1)
end if

if defined APP_WIN64
	extrn '__imp___WSAFDIsSet' as __WSAFDIsSet:qword
	extrn '__imp_accept' as accept:qword
	extrn '__imp_AcceptEx' as AcceptEx:qword
	extrn '__imp_bind' as bind:qword
	extrn '__imp_closesocket' as closesocket:qword
	extrn '__imp_connect' as connect:qword
	extrn '__imp_dn_expand' as dn_expand:qword
	extrn '__imp_EnumProtocolsA' as EnumProtocolsA:qword
	extrn '__imp_EnumProtocolsW' as EnumProtocolsW:qword
	extrn '__imp_GetAcceptExSockaddrs' as GetAcceptExSockaddrs:qword
	extrn '__imp_GetAddressByNameA' as GetAddressByNameA:qword
	extrn '__imp_GetAddressByNameW' as GetAddressByNameW:qword
	extrn '__imp_gethostbyaddr' as gethostbyaddr:qword
	extrn '__imp_gethostbyname' as gethostbyname:qword
	extrn '__imp_gethostname' as gethostname:qword
	extrn '__imp_GetNameByTypeA' as GetNameByTypeA:qword
	extrn '__imp_GetNameByTypeW' as GetNameByTypeW:qword
	extrn '__imp_getnetbyname' as getnetbyname:qword
	extrn '__imp_getpeername' as getpeername:qword
	extrn '__imp_getprotobyname' as getprotobyname:qword
	extrn '__imp_getprotobynumber' as getprotobynumber:qword
	extrn '__imp_getservbyname' as getservbyname:qword
	extrn '__imp_getservbyport' as getservbyport:qword
	extrn '__imp_GetServiceA' as GetServiceA:qword
	extrn '__imp_GetServiceW' as GetServiceW:qword
	extrn '__imp_getsockname' as getsockname:qword
	extrn '__imp_getsockopt' as getsockopt:qword
	extrn '__imp_GetTypeByNameA' as GetTypeByNameA:qword
	extrn '__imp_GetTypeByNameW' as GetTypeByNameW:qword
	extrn '__imp_htonl' as htonl:qword
	extrn '__imp_htons' as htons:qword
	extrn '__imp_inet_addr' as inet_addr:qword
	extrn '__imp_inet_network' as inet_network:qword
	extrn '__imp_inet_ntoa' as inet_ntoa:qword
	extrn '__imp_ioctlsocket' as ioctlsocket:qword
	extrn '__imp_listen' as listen:qword
	extrn '__imp_MigrateWinsockConfiguration' as MigrateWinsockConfiguration:qword
	extrn '__imp_NPLoadNameSpaces' as NPLoadNameSpaces:qword
	extrn '__imp_ntohl' as ntohl:qword
	extrn '__imp_ntohs' as ntohs:qword
	extrn '__imp_rcmd' as rcmd:qword
	extrn '__imp_recv' as recv:qword
	extrn '__imp_recvfrom' as recvfrom:qword
	extrn '__imp_rexec' as rexec:qword
	extrn '__imp_rresvport' as rresvport:qword
	extrn '__imp_s_perror' as s_perror:qword
	extrn '__imp_select' as select:qword
	extrn '__imp_send' as send:qword
	extrn '__imp_sendto' as sendto:qword
	extrn '__imp_sethostname' as sethostname:qword
	extrn '__imp_SetServiceA' as SetServiceA:qword
	extrn '__imp_SetServiceW' as SetServiceW:qword
	extrn '__imp_setsockopt' as setsockopt:qword
	extrn '__imp_shutdown' as shutdown:qword
	extrn '__imp_socket' as socket:qword
	extrn '__imp_TransmitFile' as TransmitFile:qword
	extrn '__imp_WEP' as WEP:qword
	extrn '__imp_WSAAsyncGetHostByAddr' as WSAAsyncGetHostByAddr:qword
	extrn '__imp_WSAAsyncGetHostByName' as WSAAsyncGetHostByName:qword
	extrn '__imp_WSAAsyncGetProtoByName' as WSAAsyncGetProtoByName:qword
	extrn '__imp_WSAAsyncGetProtoByNumber' as WSAAsyncGetProtoByNumber:qword
	extrn '__imp_WSAAsyncGetServByName' as WSAAsyncGetServByName:qword
	extrn '__imp_WSAAsyncGetServByPort' as WSAAsyncGetServByPort:qword
	extrn '__imp_WSAAsyncSelect' as WSAAsyncSelect:qword
	extrn '__imp_WSACancelAsyncRequest' as WSACancelAsyncRequest:qword
	extrn '__imp_WSACancelBlockingCall' as WSACancelBlockingCall:qword
	extrn '__imp_WSACleanup' as WSACleanup:qword
	extrn '__imp_WSAGetLastError' as WSAGetLastError:qword
	extrn '__imp_WSAIsBlocking' as WSAIsBlocking:qword
	extrn '__imp_WSARecvEx' as WSARecvEx:qword
	extrn '__imp_WSASetBlockingHook' as WSASetBlockingHook:qword
	extrn '__imp_WSASetLastError' as WSASetLastError:qword
	extrn '__imp_WSAStartup' as WSAStartup:qword
	extrn '__imp_WSAUnhookBlockingHook' as WSAUnhookBlockingHook:qword
else
	extrn '__imp____WSAFDIsSet@8' as __WSAFDIsSet:dword
	extrn '__imp__accept@12' as accept:dword
	extrn '__imp__AcceptEx@32' as AcceptEx:dword
	extrn '__imp__bind@12' as bind:dword
	extrn '__imp__closesocket@4' as closesocket:dword
	extrn '__imp__connect@12' as connect:dword
	extrn '__imp__dn_expand@20' as dn_expand:dword
	extrn '__imp__EnumProtocolsA@12' as EnumProtocolsA:dword
	extrn '__imp__EnumProtocolsW@12' as EnumProtocolsW:dword
	extrn '__imp__GetAcceptExSockaddrs@32' as GetAcceptExSockaddrs:dword
	extrn '__imp__GetAddressByNameA@40' as GetAddressByNameA:dword
	extrn '__imp__GetAddressByNameW@40' as GetAddressByNameW:dword
	extrn '__imp__gethostbyaddr@12' as gethostbyaddr:dword
	extrn '__imp__gethostbyname@4' as gethostbyname:dword
	extrn '__imp__gethostname@8' as gethostname:dword
	extrn '__imp__GetNameByTypeA@12' as GetNameByTypeA:dword
	extrn '__imp__GetNameByTypeW@12' as GetNameByTypeW:dword
	extrn '__imp__getnetbyname@4' as getnetbyname:dword
	extrn '__imp__getpeername@12' as getpeername:dword
	extrn '__imp__getprotobyname@4' as getprotobyname:dword
	extrn '__imp__getprotobynumber@4' as getprotobynumber:dword
	extrn '__imp__getservbyname@8' as getservbyname:dword
	extrn '__imp__getservbyport@8' as getservbyport:dword
	extrn '__imp__GetServiceA@28' as GetServiceA:dword
	extrn '__imp__GetServiceW@28' as GetServiceW:dword
	extrn '__imp__getsockname@12' as getsockname:dword
	extrn '__imp__getsockopt@20' as getsockopt:dword
	extrn '__imp__GetTypeByNameA@8' as GetTypeByNameA:dword
	extrn '__imp__GetTypeByNameW@8' as GetTypeByNameW:dword
	extrn '__imp__htonl@4' as htonl:dword
	extrn '__imp__htons@4' as htons:dword
	extrn '__imp__inet_addr@4' as inet_addr:dword
	extrn '__imp__inet_network@4' as inet_network:dword
	extrn '__imp__inet_ntoa@4' as inet_ntoa:dword
	extrn '__imp__ioctlsocket@12' as ioctlsocket:dword
	extrn '__imp__listen@8' as listen:dword
	extrn '__imp__MigrateWinsockConfiguration@12' as MigrateWinsockConfiguration:dword
	extrn '__imp__NPLoadNameSpaces@12' as NPLoadNameSpaces:dword
	extrn '__imp__ntohl@4' as ntohl:dword
	extrn '__imp__ntohs@4' as ntohs:dword
	extrn '__imp__rcmd@24' as rcmd:dword
	extrn '__imp__recv@16' as recv:dword
	extrn '__imp__recvfrom@24' as recvfrom:dword
	extrn '__imp__rexec@24' as rexec:dword
	extrn '__imp__rresvport@4' as rresvport:dword
	extrn '__imp__s_perror@8' as s_perror:dword
	extrn '__imp__select@20' as select:dword
	extrn '__imp__send@16' as send:dword
	extrn '__imp__sendto@24' as sendto:dword
	extrn '__imp__sethostname@8' as sethostname:dword
	extrn '__imp__SetServiceA@24' as SetServiceA:dword
	extrn '__imp__SetServiceW@24' as SetServiceW:dword
	extrn '__imp__setsockopt@20' as setsockopt:dword
	extrn '__imp__shutdown@8' as shutdown:dword
	extrn '__imp__socket@12' as socket:dword
	extrn '__imp__TransmitFile@28' as TransmitFile:dword
	extrn '__imp__WEP@0' as WEP:dword
	extrn '__imp__WSAAsyncGetHostByAddr@28' as WSAAsyncGetHostByAddr:dword
	extrn '__imp__WSAAsyncGetHostByName@20' as WSAAsyncGetHostByName:dword
	extrn '__imp__WSAAsyncGetProtoByName@20' as WSAAsyncGetProtoByName:dword
	extrn '__imp__WSAAsyncGetProtoByNumber@20' as WSAAsyncGetProtoByNumber:dword
	extrn '__imp__WSAAsyncGetServByName@24' as WSAAsyncGetServByName:dword
	extrn '__imp__WSAAsyncGetServByPort@24' as WSAAsyncGetServByPort:dword
	extrn '__imp__WSAAsyncSelect@16' as WSAAsyncSelect:dword
	extrn '__imp__WSACancelAsyncRequest@4' as WSACancelAsyncRequest:dword
	extrn '__imp__WSACancelBlockingCall@0' as WSACancelBlockingCall:dword
	extrn '__imp__WSACleanup@0' as WSACleanup:dword
	extrn '__imp__WSAGetLastError@0' as WSAGetLastError:dword
	extrn '__imp__WSAIsBlocking@0' as WSAIsBlocking:dword
	extrn '__imp__WSARecvEx@16' as WSARecvEx:dword
	extrn '__imp__WSASetBlockingHook@4' as WSASetBlockingHook:dword
	extrn '__imp__WSASetLastError@4' as WSASetLastError:dword
	extrn '__imp__WSAStartup@8' as WSAStartup:dword
	extrn '__imp__WSAUnhookBlockingHook@0' as WSAUnhookBlockingHook:dword
end if

if defined APP_UNICODE
	EnumProtocols equ EnumProtocolsW
	GetAddressByName equ GetAddressByNameW
	GetNameByType equ GetNameByTypeW
	GetService equ GetServiceW
	GetTypeByName equ GetTypeByNameW
	SetService equ SetServiceW
else
	EnumProtocols equ EnumProtocolsA
	GetAddressByName equ GetAddressByNameA
	GetNameByType equ GetNameByTypeA
	GetService equ GetServiceA
	GetTypeByName equ GetTypeByNameA
	SetService equ SetServiceA
end if

end if ;WSOCK32_INC
